GPRINT ; GPRINT filespec<CR>
 ;
 ; A line printer spooler designed to work in conjunction
 ; with DATADUMP/CMD.
 ; (c) 1981 by John J. Schultz, placed in public domain.
 ;
 ; This program will monitor all characters going through
 ; the line printer driver. If an ascii null (00H) is
 ; received, the file 'filespec' will be opened, all of
 ; its contents will be sequentially sent to the printer
 ; until the file is empty, and the file will be closed.
 ; Control at this point is returned to wherever the line
 ; printer driver was called from.
 ;
 ;
 OPEN	EQU	4424H
 REWIND	EQU	443FH
 READ	EQU	4436H
 CLOSE	EQU	4428H
 ERROR	EQU	4409H
 HIMEM	EQU	4049H
 LPDRVE	EQU	4026H
 DOS	EQU	402DH
 DISPA	EQU	0033H
 MEM16K	EQU	7C00H
 MEM32K	EQU	0BC00H
 MEM48K	EQU	0FC00H
 	ORG	MEM48K
 START	LD	B,0
 	LD	DE,DCB
 LOOP1	LD	A,(HL)
 	LD	(DE),A
 	CP	0DH
 	JR	Z,CONT1
 	INC	HL
 	INC	DE
 	INC	B
 	JR	LOOP1
 CONT1	LD	A,B
 	OR	A
 	JR	NZ,CONT2
 	LD	HL,NFSPC
 	CALL	DISPHL
 	JP	DOS
 CONT2	XOR	A
 	LD	DE,DCB
 	LD	HL,BUFFER
 	LD	B,0
 	CALL	OPEN
 	JR	NZ,DISERR
 	LD	DE,DCB
 	CALL	CLOSE
 	CALL	ZBUFF
 	LD	HL,START-1
 	LD	(HIMEM),HL
 	LD	HL,(LPDRVE)
 	LD	(NMDRVE+1),HL
 	LD	HL,START2
 	LD	(LPDRVE),HL
 	JP	DOS
 START2	LD	A,C
 	OR	A
 	JR	NZ,NMDRVE
 	LD	DE,DCB
 	LD	HL,BUFFER
 	LD	B,0
 	CALL	OPEN
 	JR	NZ,DISERR
 	LD	DE,DCB
 	CALL	REWIND
 	JR	NZ,DISERR
 	CALL	ZBUFF
 	XOR	A
 	LD	(COUNT),A
 CONT3	LD	A,(COUNT)
 	OR	A
 	CALL	Z,GETBUF
 	LD	HL,(BUFPTR)
 	LD	A,(HL)
 	OR	A
 	JR	Z,END
 	INC	HL
 	LD	(BUFPTR),HL
 	LD	C,A
 	CALL	NMDRVE
 	LD	A,(COUNT)
 	DEC	A
 	LD	(COUNT),A
 	JR	CONT3
 GETBUF	CALL	ZBUFF
 	LD	DE,DCB
 	CALL	READ
 	JR	NZ,DISERR
 	RET
 ZBUFF	LD	B,0
 	LD	HL,BUFFER
 	LD	(BUFPTR),HL
 LOOP2	LD	(HL),0
 	INC	HL
 	DJNZ	LOOP2
 	RET
 DISERR	OR	0C0H
 	CALL	ERROR
 	LD	DE,DCB
 	CALL	CLOSE
 	RET
 END	LD	DE,DCB
 	CALL	CLOSE
 	JR	NZ,DISERR
 	RET
 DISPHL	LD	A,(HL)
 	PUSH	AF
 	AND	7FH
 	CALL	DISPA
 	POP	AF
 	INC	HL
 	BIT	7,A
 	JR	Z,DISPHL
 	RET
 COUNT	DEFB	0
 BUFPTR	DEFW	BUFFER
 NMDRVE	CALL	$-$
 	RET
 BUFFER	DEFS	256
 DCB	DEFS	50
 NFSPC	DEFM	'No filespec'
 	DEFB	8DH
 	END	START
